from note_storage.cli.errors import exit_on_unsuccesful_response
from note_storage.gateways import SQLiteNoteGateway, SQLiteTagGateway
from note_storage.interactors import AddTagsToNoteInteractor
from note_storage.requests import AddTagsToNoteRequest


async def add_tags(db, note_id, tag_names):
    interactor = AddTagsToNoteInteractor(
        SQLiteNoteGateway(db), SQLiteTagGateway(db), note_id
    )

    response = await interactor.execute(
        await AddTagsToNoteRequest.from_dict({'tag_names': tag_names})
    )

    exit_on_unsuccesful_response(response)

    return response.value
