from note_storage.cli.errors import exit_on_unsuccesful_response
from note_storage.gateways import SQLiteNoteGateway
from note_storage.interactors import RemoveNoteInteractor
from note_storage.requests import RemoveNoteRequest


async def drop(db, hex_id):
    interactor = RemoveNoteInteractor(SQLiteNoteGateway(db))
    response = await interactor.execute(
        await RemoveNoteRequest.from_dict({'hex_id': hex_id})
    )

    exit_on_unsuccesful_response(response)

    return response.value
