import secrets

from note_storage.cli.errors import exit_on_unsuccesful_response
from note_storage.gateways import SQLiteNoteGateway
from note_storage.interactors import CreateNoteInteractor
from note_storage.requests import CreateNoteRequest


async def push(db, extension, body, tag_names):
    interactor = CreateNoteInteractor(
        SQLiteNoteGateway(db), lambda: secrets.token_hex(2)
    )
    response = await interactor.execute(
        await CreateNoteRequest.from_dict(
            {'note_ext': extension, 'note_body': body, 'tag_names': tag_names}
        )
    )

    exit_on_unsuccesful_response(response)

    return response.value
