from note_storage.cli.errors import exit_on_unsuccesful_response
from note_storage.gateways import SQLiteNoteGateway, SQLiteTagGateway
from note_storage.interactors import RemoveTagsFromNoteInteractor
from note_storage.requests import RemoveTagsFromNoteRequest


async def remove_tags(db, note_id, tag_names):
    interactor = RemoveTagsFromNoteInteractor(
        SQLiteNoteGateway(db), SQLiteTagGateway(db), note_id
    )

    response = await interactor.execute(
        await RemoveTagsFromNoteRequest.from_dict({'tag_names': tag_names})
    )

    exit_on_unsuccesful_response(response)

    return response.value
