from note_storage.cli.errors import exit_on_unsuccesful_response
from note_storage.gateways import SQLiteTagGateway
from note_storage.interactors import RenameTagInteractor
from note_storage.requests import RenameTagRequest


async def rename_tag(db, old_name, new_name):
    interactor = RenameTagInteractor(SQLiteTagGateway(db))

    response = await interactor.execute(
        await RenameTagRequest.from_dict(
            {'old_name': old_name, 'new_name': new_name}
        )
    )

    exit_on_unsuccesful_response(response)

    return response.value
