import os
import platform
import subprocess
import sys
from shutil import which


def copy_to_clipboard(content):
    subprocess.run(
        get_copy_command().split(), check=True, input=content.encode()
    )


def get_copy_command():
    if (os_ := platform.system()) == 'Linux':
        if os.getenv('XDG_SESSION_TYPE') == 'wayland' and not which('wl-copy'):
            sys.exit(
                'You should install "wl-clipboard"'
                ' to use --to-clipboard option'
            )
            return 'wl-copy'

        if not which('xclip'):
            sys.exit('You should install "xclip" to use --to-clipboard option')

        return 'xclip -sel clip'

    if os_ == 'Darwin':
        return 'pbcopy'

    sys.exit('"--to-clipboard" option is not supported on your platform')
