import sys


def loads_note(text):
    if (body_start := text.find('\n\n')) == -1:
        sys.exit('No empty line found')

    note_body = text[(body_start + 2) :].strip()
    if not note_body:
        sys.exit('Empty note body')

    tag_names = text[:body_start].split()

    return note_body, tag_names


def dumps_note(note_body, tag_names):
    if not tag_names:
        return note_body

    formatted_tag_names = '\n'.join(sorted(tag_names))
    return ''.join([formatted_tag_names, '\n\n', note_body])
