import tomlkit


class TOMLConfig:
    def __init__(self):
        self.document = tomlkit.document()

    def loads(self, config_text):
        self.document = tomlkit.loads(config_text)

    def dumps(self):
        return tomlkit.dumps(self.document)

    def set(self, group, key, value):
        self.document.setdefault(group, {})[key] = value

    def get(self, group, key):
        try:
            return self.document[group][key]
        except tomlkit.exceptions.NonExistentKey:
            return None

    def to_dict(self):
        return dict(self.document)
