import asyncio


def synchronous_get_first_validation_error(validator, input_data):
    for error in validator.iter_errors(input_data):
        return error.instance, error.message


async def get_first_validation_error(validator, input_data):
    return await asyncio.get_event_loop().run_in_executor(
        None,
        lambda: synchronous_get_first_validation_error(validator, input_data),
    )
