import os
from pathlib import Path

from note_storage.core.constants import CONFIG_FILE_NAME, PROJECT_NAME


def chunks(iterable, length):
    for pos in range(0, len(iterable), length):
        yield iterable[pos : (pos + length)]


def get_project_data_path():
    home_data_path = Path(
        os.getenv('XDG_DATA_HOME', '~/.local/share')
    ).expanduser()

    return home_data_path.joinpath(PROJECT_NAME)


def get_project_config_path():
    home_config_path = Path(
        os.getenv('XDG_CONFIG_HOME', '~/.config')
    ).expanduser()

    return home_config_path.joinpath(PROJECT_NAME, CONFIG_FILE_NAME)
