from note_storage.responses import ResponseFailure, ResponseSuccess


class GetAllNoteIDsInteractor:
    def __init__(self, gateway):
        self.gateway = gateway

    async def execute(self, request):
        if not request.is_valid:
            return ResponseFailure.build_from_invalid_request(request)

        try:
            note_ids = await self.gateway.get_all_notes_ids()
        except Exception as exc:
            message = 'Tag gateway was called without arguments'
            return ResponseFailure.build_internal_error(message, exc)

        return ResponseSuccess(note_ids)
