from note_storage.responses import ResponseFailure, ResponseSuccess


class GetLastReviewedNoteIdInteractor:
    def __init__(self, gateway):
        self.gateway = gateway

    async def execute(self, request):
        if not request.is_valid:
            return ResponseFailure.build_from_invalid_request(request)

        try:
            last_reviewed_id = await self.gateway.get_last_reviewed_note_id()
        except Exception as exc:
            message = 'Tag gateway was called without arguments'
            return ResponseFailure.build_internal_error(message, exc)

        return ResponseSuccess(last_reviewed_id)
