from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {
            'tag_names': {'type': 'array', 'items': {'type': 'string'}},
        },
        'required': ['tag_names'],
    }
)

validator.check_schema(validator.schema)


class AddTagsToNoteRequest(ValidRequest):
    def __init__(self, tag_names):
        self.tag_names = tag_names

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['tag_names'])
