from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {'type': 'object', 'properties': {}, 'additionalProperties': False}
)

validator.check_schema(validator.schema)


class DeleteLastReviewedNoteIdRequest(ValidRequest):
    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls()
