from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {
            'note_ids': {'type': 'array', 'items': {'type': 'integer'}}
        },
        'additionalProperties': False,
    }
)

validator.check_schema(validator.schema)


class GetHexIDsByNoteIDsRequest(ValidRequest):
    def __init__(self, note_ids):
        self.note_ids = note_ids

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['note_ids'])
