from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {
            'tag_ids': {'type': 'array', 'items': {'type': 'integer'}}
        },
        'required': ['tag_ids'],
    }
)

validator.check_schema(validator.schema)


class GetNoteIdsByTagIdsRequest(ValidRequest):
    def __init__(self, tag_ids):
        self.tag_ids = tag_ids

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['tag_ids'])
