from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {'hex_id': {'type': 'string'}},
        'required': ['hex_id'],
    }
)

validator.check_schema(validator.schema)


class RemoveNoteRequest(ValidRequest):
    def __init__(self, hex_id):
        self.hex_id = hex_id

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['hex_id'])
