from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {
            'old_name': {'type': 'string'},
            'new_name': {'type': 'string'},
        },
        'required': ['old_name', 'new_name'],
    }
)

validator.check_schema(validator.schema)


class RenameTagRequest(ValidRequest):
    def __init__(self, old_name, new_name):
        self.old_name = old_name
        self.new_name = new_name

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['old_name'], dict_['new_name'])
