from jsonschema import Draft7Validator

from .base_request import ValidRequest
from .validation import validate_request

validator = Draft7Validator(
    {
        'type': 'object',
        'properties': {'last_reviewed_id': {'type': 'integer'}},
        'required': ['last_reviewed_id'],
    }
)

validator.check_schema(validator.schema)


class SetLastReviewedNoteIdRequest(ValidRequest):
    def __init__(self, last_reviewed_id):
        self.last_reviewed_id = last_reviewed_id

    @classmethod
    async def from_dict(cls, dict_):
        if invalid_request := (await validate_request(validator, dict_)):
            return invalid_request

        return cls(dict_['last_reviewed_id'])
